Attribute VB_Name = "mod_90_Decodes"
Option Explicit
Option Private Module

Function DecodeFileFormat(x As XlFileFormat) As String
    Select Case x
        Case xlAddIn: DecodeFileFormat = "Microsoft Office Excel Add-In"
        Case xlCSV: DecodeFileFormat = "Comma separated value"
        Case xlCSVMac: DecodeFileFormat = "Comma separated value"
        Case xlCSVMSDOS: DecodeFileFormat = "Comma separated value"
        Case xlCSVWindows: DecodeFileFormat = "Comma separated value"
        Case xlDBF2: DecodeFileFormat = "Dbase 2 format"
        Case xlDBF3: DecodeFileFormat = "Dbase 3 format"
        Case xlDBF4: DecodeFileFormat = "Dbase 4 format"
        Case xlDIF: DecodeFileFormat = "Data Interchange format"
        Case xlExcel2: DecodeFileFormat = "Excel version 2.0"
        Case xlExcel2FarEast: DecodeFileFormat = "Excel version 2.0 far east"
        Case xlExcel3: DecodeFileFormat = "Excel version 3.0"
        Case xlExcel4: DecodeFileFormat = "Excel version 4.0"
        Case xlExcel5: DecodeFileFormat = "Excel version 5.0"
        Case xlExcel7: DecodeFileFormat = "Excel 95"
        Case xlExcel9795: DecodeFileFormat = "Excel version 95 and 97"
        Case xlExcel4Workbook: DecodeFileFormat = "Excel version 4.0. Workbook format"
        Case xlIntlAddIn: DecodeFileFormat = "Microsoft Office Excel Add-In international format"
        Case xlIntlMacro: DecodeFileFormat = "Deprecated format"
        Case xlWorkbookNormal: DecodeFileFormat = "Excel workbook format"
        Case xlSYLK: DecodeFileFormat = "Symbolic link format"
        Case xlTemplate: DecodeFileFormat = "Excel template format"
        Case xlCurrentPlatformText: DecodeFileFormat = "Specifies a type of text format"
        Case xlTextMac: DecodeFileFormat = "Specifies a type of text format"
        Case xlTextMSDOS: DecodeFileFormat = "Specifies a type of text format"
        Case xlTextPrinter: DecodeFileFormat = "Specifies a type of text format"
        Case xlTextWindows: DecodeFileFormat = "Specifies a type of text format"
        Case xlWJ2WD1: DecodeFileFormat = "Deprecated format"
        Case xlWK1: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWK1ALL: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWK1FMT: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWK3: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWK4: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWK3FM3: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWKS: DecodeFileFormat = "Lotus 1-2-3 format"
        Case xlWorks2FarEast: DecodeFileFormat = "Microsoft Works 2.0 format"
        Case xlWQ1: DecodeFileFormat = "Quattro Pro format"
        Case xlWJ3: DecodeFileFormat = "Deprecated format"
        Case xlWJ3FJ3: DecodeFileFormat = "Deprecated format"
        Case xlUnicodeText: DecodeFileFormat = "Specifies a type of text format"
        Case xlHtml: DecodeFileFormat = "Web page format"
        Case xlWebArchive: DecodeFileFormat = "MHT format"
        Case xlXMLSpreadsheet: DecodeFileFormat = "Excel Spreadsheet format"
        
        'Not Available in Excel 2002
        'Case xlExcel12: DecodeFileFormat = "Excel12"
        'Case xlOpenXMLWorkbook: DecodeFileFormat = "Open XML Workbook"
        'Case xlOpenXMLWorkbookMacroEnabled: DecodeFileFormat = "Open XML Workbook Macro Enabled"
        'Case xlOpenXMLTemplateMacroEnabled: DecodeFileFormat = "Open XML Template Macro Enabled"
        'Case xlTemplate8: DecodeFileFormat = "Template 8"
        'Case xlOpenXMLTemplate: DecodeFileFormat = "Open XML Template"
        'Case xlAddIn8: DecodeFileFormat = "Microsoft Excel 97-2003 Add-In"
        'Case xlOpenXMLAddIn: DecodeFileFormat = "Open XML Add-In"
        'Case xlExcel8: DecodeFileFormat = "Excel8"
        'Case xlOpenDocumentSpreadsheet: DecodeFileFormat = "OpenDocument Spreadsheet"
        'Case xlOpenXMLStrictWorkbook: DecodeFileFormat = "Strict Open XML file"
        'Case xlWorkbookDefault: DecodeFileFormat = "Workbook default"
        
        Case Else
            DecodeFileFormat = "Other"
    End Select

End Function


Function DecodeSheetVisibility(x As XlSheetVisibility) As String
    Select Case x
        Case xlSheetVisible
            DecodeSheetVisibility = "Visible"
        Case xlSheetHidden
            DecodeSheetVisibility = "Hidden"
        Case xlSheetVeryHidden
            DecodeSheetVisibility = "Very Hidden"
        Case Else
            DecodeSheetVisibility = "Other"
    End Select
End Function

Function DecodeShapeType(x As MsoShapeType) As String
    Select Case x
        Case msoAutoShape: DecodeShapeType = "AutoShape"
        Case msoCallout: DecodeShapeType = "Callout"
        Case msoCanvas: DecodeShapeType = "Canvas"
        Case msoChart: DecodeShapeType = "Chart"
        Case msoComment: DecodeShapeType = "Comment"
        Case msoDiagram: DecodeShapeType = "Diagram"
        Case msoEmbeddedOLEObject: DecodeShapeType = "Embedded OLE object"
        Case msoFormControl: DecodeShapeType = "Form control"
        Case msoFreeform: DecodeShapeType = "Freeform"
        Case msoGroup: DecodeShapeType = "Group"
        Case msoLine: DecodeShapeType = "Line"
        Case msoLinkedOLEObject: DecodeShapeType = "Linked OLE object"
        Case msoLinkedPicture: DecodeShapeType = "Linked picture"
        Case msoMedia: DecodeShapeType = "Media"
        Case msoOLEControlObject: DecodeShapeType = "OLE control object"
        Case msoPicture: DecodeShapeType = "Picture"
        Case msoPlaceholder: DecodeShapeType = "Placeholder"
        Case msoScriptAnchor: DecodeShapeType = "Script anchor"
        Case msoShapeTypeMixed: DecodeShapeType = "Mixed shape type"
        Case msoTable: DecodeShapeType = "Table"
        Case msoTextBox: DecodeShapeType = "Text box"
        Case msoTextEffect: DecodeShapeType = "Text effect"
        
        'Not Available in Excel 2002
        'Case msoContentApp: DecodeShapeType = "Content Office Add-in"
        'Case msoGraphic: DecodeShapeType = "Graphic"
        'Case msoIgxGraphic: DecodeShapeType = "SmartArt graphic"
        'Case msoInk: DecodeShapeType = "Ink"
        'Case msoInkComment: DecodeShapeType = "Ink comment"
        'Case msoLinkedGraphic: DecodeShapeType = "Linked graphic"
        'Case msoWebVideo: DecodeShapeType = "Web video"
        Case Else
            DecodeShapeType = "Other"
    End Select


End Function


Function DecodeAutoShapeType(x As MsoAutoShapeType) As String
    Select Case x
    
        Case msoShape16pointStar: DecodeAutoShapeType = "16-point star"
        Case msoShape24pointStar: DecodeAutoShapeType = "24-point star"
        Case msoShape32pointStar: DecodeAutoShapeType = "32-point star"
        Case msoShape4pointStar: DecodeAutoShapeType = "4-point star"
        Case msoShape5pointStar: DecodeAutoShapeType = "5-point star"
        Case msoShape8pointStar: DecodeAutoShapeType = "8-point star"
        Case msoShapeActionButtonBackorPrevious: DecodeAutoShapeType = "Back or Previous button"
        Case msoShapeActionButtonBeginning: DecodeAutoShapeType = "Beginning button"
        Case msoShapeActionButtonCustom: DecodeAutoShapeType = "Button with no default picture or text"
        Case msoShapeActionButtonDocument: DecodeAutoShapeType = "Document button"
        Case msoShapeActionButtonEnd: DecodeAutoShapeType = "End button"
        Case msoShapeActionButtonForwardorNext: DecodeAutoShapeType = "Forward or Next button"
        Case msoShapeActionButtonHelp: DecodeAutoShapeType = "Help button"
        Case msoShapeActionButtonHome: DecodeAutoShapeType = "Home button"
        Case msoShapeActionButtonInformation: DecodeAutoShapeType = "Information button"
        Case msoShapeActionButtonMovie: DecodeAutoShapeType = "Movie button"
        Case msoShapeActionButtonReturn: DecodeAutoShapeType = "Return button"
        Case msoShapeActionButtonSound: DecodeAutoShapeType = "Sound button"
        Case msoShapeArc: DecodeAutoShapeType = "Arc"
        Case msoShapeBalloon: DecodeAutoShapeType = "Balloon"
        Case msoShapeBentArrow: DecodeAutoShapeType = "Block arrow that follows a curved 90-degree angle"
        Case msoShapeBentUpArrow: DecodeAutoShapeType = "Block arrow that follows a sharp 90-degree angle Points up by default"
        Case msoShapeBevel: DecodeAutoShapeType = "Bevel"
        Case msoShapeBlockArc: DecodeAutoShapeType = "Block arc"
        Case msoShapeCan: DecodeAutoShapeType = "Can"
        Case msoShapeChevron: DecodeAutoShapeType = "Chevron"
        Case msoShapeCircularArrow: DecodeAutoShapeType = "Block arrow that follows a curved 180-degree angle"
        Case msoShapeCloudCallout: DecodeAutoShapeType = "Cloud callout"
        Case msoShapeCross: DecodeAutoShapeType = "Cross"
        Case msoShapeCube: DecodeAutoShapeType = "Cube"
        Case msoShapeCurvedDownArrow: DecodeAutoShapeType = "Block arrow that curves down"
        Case msoShapeCurvedDownRibbon: DecodeAutoShapeType = "Ribbon banner that curves down"
        Case msoShapeCurvedLeftArrow: DecodeAutoShapeType = "Block arrow that curves left"
        Case msoShapeCurvedRightArrow: DecodeAutoShapeType = "Block arrow that curves right"
        Case msoShapeCurvedUpArrow: DecodeAutoShapeType = "Block arrow that curves up"
        Case msoShapeCurvedUpRibbon: DecodeAutoShapeType = "Ribbon banner that curves up"
        Case msoShapeDiamond: DecodeAutoShapeType = "Diamond"
        Case msoShapeDonut: DecodeAutoShapeType = "Donut"
        Case msoShapeDoubleBrace: DecodeAutoShapeType = "Double brace"
        Case msoShapeDoubleBracket: DecodeAutoShapeType = "Double bracket"
        Case msoShapeDoubleWave: DecodeAutoShapeType = "Double wave"
        Case msoShapeDownArrow: DecodeAutoShapeType = "Block arrow that points down"
        Case msoShapeDownArrowCallout: DecodeAutoShapeType = "Callout with arrow that points down"
        Case msoShapeDownRibbon: DecodeAutoShapeType = "Ribbon banner with center area below ribbon ends"
        Case msoShapeExplosion1: DecodeAutoShapeType = "Explosion"
        Case msoShapeExplosion2: DecodeAutoShapeType = "Explosion"
        Case msoShapeFlowchartAlternateProcess: DecodeAutoShapeType = "Alternate process flowchart symbol"
        Case msoShapeFlowchartCard: DecodeAutoShapeType = "Card flowchart symbol"
        Case msoShapeFlowchartCollate: DecodeAutoShapeType = "Collate flowchart symbol"
        Case msoShapeFlowchartConnector: DecodeAutoShapeType = "Connector flowchart symbol"
        Case msoShapeFlowchartData: DecodeAutoShapeType = "Data flowchart symbol"
        Case msoShapeFlowchartDecision: DecodeAutoShapeType = "Decision flowchart symbol"
        Case msoShapeFlowchartDelay: DecodeAutoShapeType = "Delay flowchart symbol"
        Case msoShapeFlowchartDirectAccessStorage: DecodeAutoShapeType = "Direct access storage flowchart symbol"
        Case msoShapeFlowchartDisplay: DecodeAutoShapeType = "Display flowchart symbol"
        Case msoShapeFlowchartDocument: DecodeAutoShapeType = "Document flowchart symbol"
        Case msoShapeFlowchartExtract: DecodeAutoShapeType = "Extract flowchart symbol"
        Case msoShapeFlowchartInternalStorage: DecodeAutoShapeType = "Internal storage flowchart symbol"
        Case msoShapeFlowchartMagneticDisk: DecodeAutoShapeType = "Magnetic disk flowchart symbol"
        Case msoShapeFlowchartManualInput: DecodeAutoShapeType = "Manual input flowchart symbol"
        Case msoShapeFlowchartManualOperation: DecodeAutoShapeType = "Manual operation flowchart symbol"
        Case msoShapeFlowchartMerge: DecodeAutoShapeType = "Merge flowchart symbol"
        Case msoShapeFlowchartMultidocument: DecodeAutoShapeType = "Multi-document flowchart symbol"
        Case msoShapeFlowchartOffpageConnector: DecodeAutoShapeType = "Off-page connector flowchart symbol"
        Case msoShapeFlowchartOr: DecodeAutoShapeType = "" Or " flowchart symbol"
        Case msoShapeFlowchartPredefinedProcess: DecodeAutoShapeType = "Predefined process flowchart symbol"
        Case msoShapeFlowchartPreparation: DecodeAutoShapeType = "Preparation flowchart symbol"
        Case msoShapeFlowchartProcess: DecodeAutoShapeType = "Process flowchart symbol"
        Case msoShapeFlowchartPunchedTape: DecodeAutoShapeType = "Punched tape flowchart symbol"
        Case msoShapeFlowchartSequentialAccessStorage: DecodeAutoShapeType = "Sequential access storage flowchart symbol"
        Case msoShapeFlowchartSort: DecodeAutoShapeType = "Sort flowchart symbol"
        Case msoShapeFlowchartStoredData: DecodeAutoShapeType = "Stored data flowchart symbol"
        Case msoShapeFlowchartSummingJunction: DecodeAutoShapeType = "Summing junction flowchart symbol"
        Case msoShapeFlowchartTerminator: DecodeAutoShapeType = "Terminator flowchart symbol"
        Case msoShapeFoldedCorner: DecodeAutoShapeType = "Folded corner"
        Case msoShapeHeart: DecodeAutoShapeType = "Heart"
        Case msoShapeHexagon: DecodeAutoShapeType = "Hexagon"
        Case msoShapeHorizontalScroll: DecodeAutoShapeType = "Horizontal scroll"
        Case msoShapeIsoscelesTriangle: DecodeAutoShapeType = "Isosceles triangle"
        Case msoShapeLeftArrow: DecodeAutoShapeType = "Block arrow that points left"
        Case msoShapeLeftArrowCallout: DecodeAutoShapeType = "Callout with arrow that points left"
        Case msoShapeLeftBrace: DecodeAutoShapeType = "Left brace"
        Case msoShapeLeftBracket: DecodeAutoShapeType = "Left bracket"
        Case msoShapeLeftRightArrow: DecodeAutoShapeType = "Block arrow with arrowheads that point both left and right"
        Case msoShapeLeftRightArrowCallout: DecodeAutoShapeType = "Callout with arrowheads that point both left and right"
        Case msoShapeLeftRightUpArrow: DecodeAutoShapeType = "Block arrow with arrowheads that point left, right, and up"
        Case msoShapeLeftUpArrow: DecodeAutoShapeType = "Block arrow with arrowheads that point left and up"
        Case msoShapeLightningBolt: DecodeAutoShapeType = "Lightning bolt"
        Case msoShapeLineCallout1: DecodeAutoShapeType = "Callout with border and horizontal callout line"
        Case msoShapeLineCallout1AccentBar: DecodeAutoShapeType = "Callout with horizontal accent bar"
        Case msoShapeLineCallout1BorderandAccentBar: DecodeAutoShapeType = "Callout with border and horizontal accent bar"
        Case msoShapeLineCallout1NoBorder: DecodeAutoShapeType = "Callout with horizontal line"
        Case msoShapeLineCallout2: DecodeAutoShapeType = "Callout with diagonal straight line"
        Case msoShapeLineCallout2AccentBar: DecodeAutoShapeType = "Callout with diagonal callout line and accent bar"
        Case msoShapeLineCallout2BorderandAccentBar: DecodeAutoShapeType = "Callout with border, diagonal straight line, and accent bar"
        Case msoShapeLineCallout2NoBorder: DecodeAutoShapeType = "Callout with no border and diagonal callout line"
        Case msoShapeLineCallout3: DecodeAutoShapeType = "Callout with angled line"
        Case msoShapeLineCallout3AccentBar: DecodeAutoShapeType = "Callout with angled callout line and accent bar"
        Case msoShapeLineCallout3BorderandAccentBar: DecodeAutoShapeType = "Callout with border, angled callout line, and accent bar"
        Case msoShapeLineCallout3NoBorder: DecodeAutoShapeType = "Callout with no border and angled callout line"
        Case msoShapeLineCallout4: DecodeAutoShapeType = "Callout with callout line segments forming a U-shape"
        Case msoShapeLineCallout4AccentBar: DecodeAutoShapeType = "Callout with accent bar and callout line segments forming a U-shape"
        Case msoShapeLineCallout4BorderandAccentBar: DecodeAutoShapeType = "Callout with border, accent bar, and callout line segments forming a U-shape"
        Case msoShapeLineCallout4NoBorder: DecodeAutoShapeType = "Callout with no border and callout line segments forming a U-shape"
        Case msoShapeMixed: DecodeAutoShapeType = "Return value only; indicates a combination of the other states"
        Case msoShapeMoon: DecodeAutoShapeType = "Moon"
        Case msoShapeNoSymbol: DecodeAutoShapeType = "No symbol"
        Case msoShapeNotchedRightArrow: DecodeAutoShapeType = "Notched block arrow that points right"
        Case msoShapeNotPrimitive: DecodeAutoShapeType = "Not supported"
        Case msoShapeOctagon: DecodeAutoShapeType = "Octagon"
        Case msoShapeOval: DecodeAutoShapeType = "Oval"
        Case msoShapeOvalCallout: DecodeAutoShapeType = "Oval-shaped callout"
        Case msoShapeParallelogram: DecodeAutoShapeType = "Parallelogram"
        Case msoShapePentagon: DecodeAutoShapeType = "Pentagon"
        Case msoShapePlaque: DecodeAutoShapeType = "Plaque"
        Case msoShapeQuadArrow: DecodeAutoShapeType = "Block arrows that point up, down, left, and right"
        Case msoShapeQuadArrowCallout: DecodeAutoShapeType = "Callout with arrows that point up, down, left, and right"
        Case msoShapeRectangle: DecodeAutoShapeType = "Rectangle"
        Case msoShapeRectangularCallout: DecodeAutoShapeType = "Rectangular callout"
        Case msoShapeRegularPentagon: DecodeAutoShapeType = "Pentagon"
        Case msoShapeRightArrow: DecodeAutoShapeType = "Block arrow that points right"
        Case msoShapeRightArrowCallout: DecodeAutoShapeType = "Callout with arrow that points right"
        Case msoShapeRightBrace: DecodeAutoShapeType = "Right brace"
        Case msoShapeRightBracket: DecodeAutoShapeType = "Right bracket"
        Case msoShapeRightTriangle: DecodeAutoShapeType = "Right triangle"
        Case msoShapeRoundedRectangle: DecodeAutoShapeType = "Rounded rectangle"
        Case msoShapeRoundedRectangularCallout: DecodeAutoShapeType = "Rounded rectangle-shaped callout"
        Case msoShapeSmileyFace: DecodeAutoShapeType = "Smiley face"
        Case msoShapeStripedRightArrow: DecodeAutoShapeType = "Block arrow that points right with stripes at the tail"
        Case msoShapeSun: DecodeAutoShapeType = "Sun"
        Case msoShapeTrapezoid: DecodeAutoShapeType = "Trapezoid"
        Case msoShapeUpArrow: DecodeAutoShapeType = "Block arrow that points up"
        Case msoShapeUpArrowCallout: DecodeAutoShapeType = "Callout with arrow that points up"
        Case msoShapeUpDownArrow: DecodeAutoShapeType = "Block arrow that points up and down"
        Case msoShapeUpDownArrowCallout: DecodeAutoShapeType = "Callout with arrows that point up and down"
        Case msoShapeUpRibbon: DecodeAutoShapeType = "Ribbon banner with center area above ribbon ends"
        Case msoShapeUTurnArrow: DecodeAutoShapeType = "Block arrow forming a U shape"
        Case msoShapeVerticalScroll: DecodeAutoShapeType = "Vertical scroll"
        Case msoShapeWave: DecodeAutoShapeType = "Wave"
    
    'Not available in Excel 2002
        'Case msoShape10pointStar: DecodeAutoShapeType = "10-point star"
        'Case msoShape12pointStar: DecodeAutoShapeType = "12-point star"
        'Case msoShape6pointStar: DecodeAutoShapeType = "6-point star"
        'Case msoShape7pointStar: DecodeAutoShapeType = "7-point star"
        'Case msoShapeChartPlus: DecodeAutoShapeType = "Square divided vertically and horizontally into four quarters"
        'Case msoShapeChartStar: DecodeAutoShapeType = "Square divided six parts along vertical and diagonal lines"
        'Case msoShapeChartX: DecodeAutoShapeType = "Square divided into four parts along diagonal lines"
        'Case msoShapeCloud: DecodeAutoShapeType = "Cloud shape"
        'Case msoShapeCorner: DecodeAutoShapeType = "Rectangle with rectangular-shaped hole"
        'Case msoShapeCornerTabs: DecodeAutoShapeType = "Four right triangles aligning along a rectangular path; four 'snipped' corners"
        'Case msoShapeDecagon: DecodeAutoShapeType = "Decagon"
        'Case msoShapeDiagonalStripe: DecodeAutoShapeType = "Rectangle with two triangles-shapes removed; a diagonal stripe"
        'Case msoShapeFlowchartOfflineStorage: DecodeAutoShapeType = "Offline storage flowchart symbol"
        'Case msoShapeFrame: DecodeAutoShapeType = "Rectangular picture frame"
        'Case msoShapeFunnel: DecodeAutoShapeType = "Funnel"
        'Case msoShapeDodecagon: DecodeAutoShapeType = "Dodecagon"
        'Case msoShapeChord: DecodeAutoShapeType = "Circle with a line connecting two points on the perimeter through the interior of the circle; a circle with a chord"
        'Case msoShapeGear6: DecodeAutoShapeType = "Gear with six teeth"
        'Case msoShapeGear9: DecodeAutoShapeType = "Gear with nine teeth"
        'Case msoShapeHalfFrame: DecodeAutoShapeType = "Half of a rectangular picture frame"
        'Case msoShapeHeptagon: DecodeAutoShapeType = "Heptagon"
        'Case msoShapeLeftCircularArrow: DecodeAutoShapeType = "Circular arrow pointing counter-clockwise"
        'Case msoShapeLeftRightCircularArrow: DecodeAutoShapeType = "Circular arrow pointing clockwise and counter-clockwise; a curved arrow with points at both ends"
        'Case msoShapeLeftRightRibbon: DecodeAutoShapeType = "Ribbon with an arrow at both ends"
        'Case msoShapeLineInverse: DecodeAutoShapeType = "Line inverse"
        'Case msoShapeMathDivide: DecodeAutoShapeType = "Division symbol ''"
        'Case msoShapeMathEqual: DecodeAutoShapeType = "Equivalence symbol '='"
        'Case msoShapeMathMinus: DecodeAutoShapeType = "Subtraction symbol '-'"
        'Case msoShapeMathMultiply: DecodeAutoShapeType = "Multiplication symbol 'x'"
        'Case msoShapeMathNotEqual: DecodeAutoShapeType = "Non-equivalence symbol '?'"
        'Case msoShapeMathPlus: DecodeAutoShapeType = "Addition symbol '+'"
        'Case msoShapeNonIsoscelesTrapezoid: DecodeAutoShapeType = "Trapezoid with asymmetrical non-parallel sides"
        'Case msoShapePie: DecodeAutoShapeType = "Circle ('pie') with a portion missing"
        'Case msoShapePieWedge: DecodeAutoShapeType = "Quarter of a circular shape"
        'Case msoShapePlaqueTabs: DecodeAutoShapeType = "Four quarter-circles defining a rectangular shape"
        'Case msoShapeRound1Rectangle: DecodeAutoShapeType = "Rectangle with one rounded corner"
        'Case msoShapeRound2DiagRectangle: DecodeAutoShapeType = "Rectangle with two rounded corners, diagonally-opposed"
        'Case msoShapeRound2SameRectangle: DecodeAutoShapeType = "Rectangle with two-rounded corners that share a side"
        'Case msoShapeSnip1Rectangle: DecodeAutoShapeType = "Rectangle with one snipped corner"
        'Case msoShapeSnip2DiagRectangle: DecodeAutoShapeType = "Rectangle with two snipped corners, diagonally-opposed"
        'Case msoShapeSnip2SameRectangle: DecodeAutoShapeType = "Rectangle with two snipped corners that share a side"
        'Case msoShapeSnipRoundRectangle: DecodeAutoShapeType = "Rectangle with one snipped corner and one rounded corner"
        'Case msoShapeSquareTabs: DecodeAutoShapeType = "Four small squares that define a rectangular shape"
        'Case msoShapeSwooshArrow: DecodeAutoShapeType = "Curved arrow"
        'Case msoShapeTear: DecodeAutoShapeType = "Water droplet"
        
        Case Else
            DecodeAutoShapeType = "Other"
    End Select


End Function


